您的位置:首页 > 其它

POJ-2488 A Knight's Journey(需注意搜索顺序的深搜)

2013-12-05 12:09 344 查看
A Knight's Journey

Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 26950 Accepted: 9195
Description


Background 

The knight is getting bored of seeing the same black and white squares again and again and has decided to make a journey 

around the world. Whenever a knight moves, it is two squares in one direction and one square perpendicular to this. The world of a knight is the chessboard he is living on. Our knight lives on a chessboard that has a smaller area than a regular 8 * 8 board,
but it is still rectangular. Can you help this adventurous knight to make travel plans? 

Problem 

Find a path such that the knight visits every square once. The knight can start and end on any square of the board.
Input

The input begins with a positive integer n in the first line. The following lines contain n test cases. Each test case consists of a single line with two positive integers p and q, such that 1 <= p * q <= 26. This represents a p * q chessboard, where p describes
how many different square numbers 1, . . . , p exist, q describes how many different square letters exist. These are the first q letters of the Latin alphabet: A, . . .
Output

The output for every scenario begins with a line containing "Scenario #i:", where i is the number of the scenario starting at 1. Then print a single line containing the lexicographically first path that visits all squares of the chessboard with knight moves
followed by an empty line. The path should be given on a single line by concatenating the names of the visited squares. Each square name consists of a capital letter followed by a number. 

If no such path exist, you should output impossible on a single line.
Sample Input
3
1 1
2 3
4 3

Sample Output
Scenario #1:
A1

Scenario #2:
impossible

Scenario #3:
A1B3C1A2B4C2A3B1C3A4B2C4

Source

TUD Programming Contest 2005, Darmstadt, Germany

思路:

         深度优先搜索,但因为最后要按字典序输出走过的路径,所以需要注意搜索方向的顺序问题;

         



代码:

#include <stdio.h>
#include <string.h>
#include <stack>
#define N 30

using namespace std;

struct Node{
int x;
int y;
};

int m, n, count;
char map

;
int fx[8][2] = {{-2,-1},{-2,1},{-1,-2},{-1,2},{1,-2},{1,2},{2,-1},{2,1}};
stack<Node>q;

int dfs(Node cur);

int main()
{
int k, t = 0;
scanf("%d", &k);
while(k --){
t ++;
while(!q.empty()) q.pop();
scanf("%d%d", &n, &m);
memset(map, '-', sizeof(map));
for(int i = 1; i <= m; i ++){
for(int j = 1; j <= n; j ++){
map[i][j] = '0';
}
}
count = 1;
Node start;
start.x = 1;
start.y = 1;
map[1][1] = '-';
int ok = dfs(start);
printf("Scenario #%d:\n", t);
if(!ok) printf("impossible");
else{
q.push(start);
while(!q.empty()){
printf("%c%d", q.top().x + 'A' - 1, q.top().y);
q.pop();
}
}
printf("\n\n");
}

return 0;
}

int dfs(Node cur)
{
if(count == m * n) return 1;
for(int i = 0; i < 8; i ++){
Node nw = cur;
nw.x += fx[i][0];
nw.y += fx[i][1];
if(nw.x <= 0 || nw.y <= 0 || map[nw.x][nw.y] == '-') continue;
else{
count ++;
map[nw.x][nw.y] = '-';
int ok = dfs(nw);
if(ok == 1){
q.push(nw);
return 1;
}
count --;
map[nw.x][nw.y] = '0';
}
}

return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  深搜